import _extends from "@babel/runtime/helpers/extends";
import "core-js/modules/es6.function.name";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import classnames from 'classnames';
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { PropTypes as MobxPropTypes } from 'mobx-react';
import withStyles from '@material-ui/core/styles/withStyles';
import Button from '@material-ui/core/Button';
import Image from './Image';
import Typography from '@material-ui/core/Typography';
import { inject, observer } from 'mobx-react';
export var styles = function styles(theme) {
  return {
    buttons: {
      display: 'flex',
      flexWrap: 'wrap',
      margin: '-4px'
    },
    button: {
      position: 'relative',
      '& button': {
        border: "1px solid ".concat(theme.palette.divider),
        padding: 0,
        margin: '4px',
        width: '60px',
        minWidth: '60px',
        height: '40px',
        minHeight: '40px',
        boxShadow: 'none'
      }
    },
    buttonWithImage: {
      '& button': {
        width: '50px',
        minWidth: '50px',
        height: '50px',
        minHeight: '50px'
      }
    },
    selectedImage: {
      '& button': {
        borderWidth: '2px',
        borderColor: theme.typography.body1.color
      }
    },
    selected: {
      '& button': {
        borderColor: theme.palette.primary.main,
        backgroundColor: theme.palette.primary.main,
        color: theme.palette.primary.contrastText,
        '&:hover': {
          borderColor: theme.palette.primary.main,
          backgroundColor: theme.palette.primary.main,
          color: theme.palette.primary.contrastText
        }
      }
    },
    imageLabel: {
      position: 'absolute',
      top: 0,
      left: 0,
      right: 0,
      bottom: 0,
      padding: '5px'
    },
    image: {
      height: '100%',
      width: '100%'
    },
    disabled: {
      backgroundColor: '#f2f2f2',
      color: '#999',
      '& img': {
        opacity: 0.5
      }
    },
    selectedName: {
      marginTop: '10px'
    },
    strikeThrough: {
      height: '7px',
      borderWidth: '2px 0',
      borderStyle: 'solid',
      borderColor: '#f2f2f2',
      backgroundColor: '#666',
      position: 'absolute',
      width: '100%',
      top: 'calc(50% - 3px)',
      borderRadius: '10px'
    }
  };
};
/**
 * A selector for product options rendered as a set of buttons. Buttons can either have
 * text or an image. The text for the selected option can optionally be displayed below
 * the buttons.
 *
 * This component supports AMP.
 */

var ButtonSelector = (_dec = inject(function (_ref) {
  var app = _ref.app,
      ampStateId = _ref.ampStateId;
  return {
    amp: app.amp,
    ampStateId: ampStateId
  };
}), _dec2 = withStyles(styles, {
  name: 'RSFButtonSelector'
}), _dec(_class = _dec2(_class = observer(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(ButtonSelector, _Component);

  function ButtonSelector() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, ButtonSelector);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(ButtonSelector)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "createButtonClass", function (isSelected, _ref2) {
      var _classnames;

      var image = _ref2.image,
          color = _ref2.color;
      var _this$props$classes = _this.props.classes,
          button = _this$props$classes.button,
          buttonWithImage = _this$props$classes.buttonWithImage,
          selectedImage = _this$props$classes.selectedImage,
          selected = _this$props$classes.selected;
      var swatch = (image || color) != null;
      return classnames((_classnames = {}, _defineProperty(_classnames, button, true), _defineProperty(_classnames, buttonWithImage, swatch), _defineProperty(_classnames, selectedImage, isSelected && swatch), _defineProperty(_classnames, selected, isSelected && !swatch), _classnames));
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "renderButton", function (option, i) {
      var _this$props = _this.props,
          classes = _this$props.classes,
          strikeThroughDisabled = _this$props.strikeThroughDisabled,
          strikeThroughAngle = _this$props.strikeThroughAngle,
          imageProps = _this$props.imageProps,
          buttonProps = _this$props.buttonProps,
          model = _this$props.model,
          ampStateId = _this$props.ampStateId,
          name = _this$props.name;
      var selected = model.selected && model.selected.id === option.id;
      var children = option.text;

      if (option.image) {
        children = React.createElement(Image, _extends({
          src: option.image,
          className: classes.image,
          fill: true
        }, imageProps, {
          alt: option.alt || option.text
        }));
      } else if (option.color) {
        children = React.createElement("div", {
          className: classes.image,
          style: {
            backgroundColor: option.color
          }
        });
      }

      return React.createElement("div", {
        key: option.id,
        className: _this.createButtonClass(selected, option),
        "amp-bind": "class=>".concat(ampStateId, ".").concat(name, ".selected.id==\"").concat(option.id, "\" ? \"").concat(_this.createButtonClass(true, option), "\" : \"").concat(_this.createButtonClass(false, option), "\"")
      }, React.createElement(Button, _extends({
        onClick: function onClick(e) {
          return _this.handleClick(e, option, i);
        },
        "aria-label": option.text,
        href: option.url,
        disabled: option.disabled,
        on: "tap:AMP.setState({ ".concat(ampStateId, ": { ").concat(name, ": { selected: ").concat(JSON.stringify(option.toJSON()), " }}})"),
        classes: {
          label: option.image || option.color ? classes.imageLabel : null,
          disabled: classes.disabled
        }
      }, buttonProps), children), option.disabled && strikeThroughDisabled && React.createElement("div", {
        className: classes.strikeThrough,
        style: {
          transform: "rotate(".concat(strikeThroughAngle, "deg)")
        }
      }));
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleClick", function (e, item, index) {
      var _this$props2 = _this.props,
          onSelectionChange = _this$props2.onSelectionChange,
          model = _this$props2.model;

      if (onSelectionChange) {
        onSelectionChange(e, item, index);

        if (e.isDefaultPrevented()) {
          return;
        }
      }

      model.setSelected(item);
    });

    return _this;
  }

  _createClass(ButtonSelector, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          amp = _this$props3.amp,
          model = _this$props3.model,
          ampStateId = _this$props3.ampStateId,
          name = _this$props3.name,
          showSelectedText = _this$props3.showSelectedText,
          classes = _this$props3.classes;
      if (!model) return null;
      return React.createElement("div", {
        className: classes.root
      }, amp && React.createElement("input", {
        type: "hidden",
        name: name,
        value: model.selected ? model.selected.id : '',
        "amp-bind": "value=>".concat(ampStateId, ".").concat(name, ".selected.id")
      }), React.createElement("div", {
        className: classes.buttons
      }, model.options.map(this.renderButton)), showSelectedText && React.createElement(Typography, {
        variant: "caption",
        component: "div",
        className: classes.selectedName,
        "amp-bind": "text=>".concat(ampStateId, ".").concat(name, ".selected.text")
      }, model.selected && model.selected.text));
    }
  }]);

  return ButtonSelector;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * The instance of SelectionModelBase to bind to
   */
  model: MobxPropTypes.objectOrObservableObject.isRequired,

  /**
   * Callback function for tab change
   * Args: event, selectedItem, index
   */
  onSelectionChange: PropTypes.func,

  /**
   * Overridable classes object to allow customization of component
   */
  classes: PropTypes.objectOf(PropTypes.string),

  /**
   * Props for displayed images. See <Image /> component for details
   */
  imageProps: PropTypes.object,

  /**
   * Props for button. See <Button /> component for details
   */
  buttonProps: PropTypes.object,

  /**
   * Set to true to show the name of the selected option in a caption below the buttons
   */
  showSelectedText: PropTypes.bool,

  /**
   * The name of property in amp state to bind to
   */
  name: PropTypes.string,

  /**
   * Set to `true` to show a slash through the item when disabled.  Defaults to `false`
   */
  strikeThroughDisabled: PropTypes.bool,

  /**
   * The angle in degress for the disabled indicator.  Defaults to `45`.
   */
  strikeThroughAngle: PropTypes.number
}), _defineProperty(_class2, "defaultProps", {
  items: [],
  buttonProps: {},
  imageProps: {},
  showSelectedText: false,
  strikeThroughDisabled: false,
  strikeThroughAngle: 45
}), _temp)) || _class) || _class) || _class);
export { ButtonSelector as default };
//# sourceMappingURL=ButtonSelector.js.map