import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import Link from './Link';
import Cart from '@material-ui/icons/ShoppingCart';
import ToolbarButton from './ToolbarButton';
import { inject, observer } from 'mobx-react';
import { withStyles } from '@material-ui/core/';
import Track from './Track';
export var styles = function styles(theme) {
  return {
    cartQuantity: {
      color: '#fff',
      backgroundColor: theme.palette.primary.main,
      height: '20px',
      width: '20px',
      lineHeight: '20px',
      fontSize: '14px',
      borderRadius: '50%',
      position: 'absolute',
      top: '3px',
      right: '5px'
    },
    icon: {}
  };
};
var CartButton = (_dec = withStyles(styles, {
  name: 'RSFCartButton'
}), _dec2 = inject(function (_ref) {
  var app = _ref.app;
  return {
    cart: app.cart
  };
}), _dec(_class = _dec2(_class = observer(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(CartButton, _Component);

  function CartButton() {
    _classCallCheck(this, CartButton);

    return _possibleConstructorReturn(this, _getPrototypeOf(CartButton).apply(this, arguments));
  }

  _createClass(CartButton, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          classes = _this$props.classes,
          cart = _this$props.cart,
          path = _this$props.path,
          server = _this$props.server,
          onClick = _this$props.onClick,
          icon = _this$props.icon,
          buttonProps = _objectWithoutProperties(_this$props, ["classes", "cart", "path", "server", "onClick", "icon"]);

      var cartIcon = icon ? icon : React.createElement(Cart, {
        className: classes.icon
      });
      return React.createElement(Track, {
        event: "cartClicked"
      }, React.createElement(Link, {
        to: path,
        server: server,
        onClick: onClick
      }, React.createElement(ToolbarButton, _extends({
        "aria-label": "Cart",
        color: "inherit",
        icon: cartIcon
      }, buttonProps), cart && cart.quantity > 0 && React.createElement("div", {
        className: classes.cartQuantity
      }, cart.quantity))));
    }
  }]);

  return CartButton;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * The url path to cart.  Defaults to "/cart"
   */
  path: PropTypes.string,

  /**
   * Set to true to force server side navigation.  Defaults to false
   */
  server: PropTypes.bool,

  /**
   * CSS classes
   */
  classes: PropTypes.object,

  /**
   * Optional Custom cart icon
   */
  icon: PropTypes.element
}), _defineProperty(_class2, "defaultProps", {
  path: '/cart'
}), _temp)) || _class) || _class) || _class);
export { CartButton as default };
//# sourceMappingURL=CartButton.js.map