import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _createClass from "@babel/runtime/helpers/createClass";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _dec3, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import ExpansionPanel from '@material-ui/core/ExpansionPanel';
import ExpansionPanelDetails from '@material-ui/core/ExpansionPanelDetails';
import ExpansionPanelSummary from '@material-ui/core/ExpansionPanelSummary';
import ExpandMoreIcon from '@material-ui/icons/ExpandMore';
import Typography from '@material-ui/core/Typography';
import withStyles from '@material-ui/core/styles/withStyles';
import AmpExpandableSection from './amp/AmpExpandableSection';
import { inject } from 'mobx-react';
import withTheme from '@material-ui/core/styles/withTheme';
export var styles = function styles(theme) {
  return {
    root: {
      boxShadow: 'none',
      borderBottom: "1px solid ".concat(theme.palette.divider),
      background: 'transparent',
      '&::before': {
        display: 'none'
      },
      '& > *:first-child': {
        padding: '0',
        minHeight: '0'
      }
    },
    margins: {
      padding: "0 ".concat(theme.margins.container, "px")
    },
    caption: {
      transition: 'opacity .2s linear'
    },
    expandedCaption: {
      opacity: 0
    },
    largeTitle: {
      fontSize: '18px',
      fontWeight: 'bold',
      color: '#444'
    },
    details: {
      padding: 0
    },
    summary: {
      display: 'flex',
      justifyContent: 'space-between',
      alignItems: 'center',
      '[aria-expanded=true] > &': {
        margin: '12px 0 !important'
      }
    },
    withCollapseIcon: {
      transform: 'translateY(-50%) rotate(0deg) !important'
    },
    summaryIconWrap: {
      right: "-".concat(theme.margins.container, "px")
    },
    expandedPanel: {
      margin: 0
    },
    expandIcon: {},
    collapseIcon: {}
  };
};
var ExpandableSection = (_dec = withStyles(styles, {
  name: 'RSFExpandableSection'
}), _dec2 = withTheme(), _dec3 = inject(function (_ref) {
  var app = _ref.app;
  return {
    amp: app.amp
  };
}), _dec(_class = _dec2(_class = _dec3(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(ExpandableSection, _Component);

  _createClass(ExpandableSection, null, [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(_ref2) {
      var expanded = _ref2.expanded;

      if (typeof expanded !== 'undefined') {
        return {
          expanded: expanded
        };
      } else {
        return {};
      }
    }
  }]);

  function ExpandableSection(_ref3) {
    var _this;

    var _expanded = _ref3.expanded,
        defaultExpanded = _ref3.defaultExpanded,
        ExpandIcon = _ref3.ExpandIcon,
        CollapseIcon = _ref3.CollapseIcon,
        theme = _ref3.theme;

    _classCallCheck(this, ExpandableSection);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ExpandableSection).call(this));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onChange", function (e, expanded) {
      if (_this.props.onChange) {
        _this.props.onChange(e, expanded);
      }

      _this.setState({
        expanded: expanded
      });
    });

    _this.ExpandIcon = ExpandIcon || theme.ExpandIcon || ExpandMoreIcon;
    _this.CollapseIcon = CollapseIcon || theme.CollapseIcon || _this.ExpandIcon;
    _this.state = {
      expanded: _expanded || defaultExpanded
    };
    return _this;
  }

  _createClass(ExpandableSection, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          amp = _this$props.amp,
          classes = _this$props.classes,
          theme = _this$props.theme,
          _this$props$children = _this$props.children,
          children = _this$props$children === void 0 ? [] : _this$props$children,
          title = _this$props.title,
          caption = _this$props.caption,
          expanded = _this$props.expanded,
          defaultExpanded = _this$props.defaultExpanded,
          ei = _this$props.ExpandIcon,
          ci = _this$props.CollapseIcon,
          margins = _this$props.margins,
          others = _objectWithoutProperties(_this$props, ["amp", "classes", "theme", "children", "title", "caption", "expanded", "defaultExpanded", "ExpandIcon", "CollapseIcon", "margins"]);

      var ExpandIcon = this.ExpandIcon,
          CollapseIcon = this.CollapseIcon;

      if (amp) {
        return React.createElement(AmpExpandableSection, {
          ExpandIcon: ExpandIcon,
          CollapseIcon: CollapseIcon,
          title: title
        }, children);
      } else {
        var _classnames, _classnames2;

        return React.createElement(ExpansionPanel, _extends({
          classes: {
            root: classnames((_classnames = {}, _defineProperty(_classnames, classes.root, true), _defineProperty(_classnames, classes.margins, margins), _defineProperty(_classnames, classes.expandedPanel, true), _classnames))
          },
          expanded: expanded,
          defaultExpanded: defaultExpanded
        }, others, {
          onChange: this.onChange
        }), React.createElement(ExpansionPanelSummary, {
          expandIcon: this.state.expanded ? React.createElement(CollapseIcon, {
            className: classes.collapseIcon
          }) : React.createElement(ExpandIcon, {
            className: classes.expandIcon
          }),
          classes: this.getSummaryClasses()
        }, React.createElement(Typography, {
          variant: "subtitle1"
        }, title), caption && React.createElement(Typography, {
          variant: "caption",
          className: classnames((_classnames2 = {}, _defineProperty(_classnames2, classes.caption, true), _defineProperty(_classnames2, classes.expandedCaption, expanded), _classnames2))
        }, caption)), React.createElement(ExpansionPanelDetails, {
          classes: {
            root: classes.details
          }
        }, children));
      }
    }
    /**
     * Gets the classes for the ExpansionPanelSummary
     * Here we add a class to remove the rotate transform if we're using a
     * separate icon for the collapse state.
     */

  }, {
    key: "getSummaryClasses",
    value: function getSummaryClasses() {
      var classes = this.props.classes;
      var result = {
        content: classes.summary,
        expandIcon: classes.summaryIconWrap
      };

      if (this.CollapseIcon !== this.ExpandIcon) {
        result.expandIcon = classes.withCollapseIcon;
      }

      return result;
    }
  }]);

  return ExpandableSection;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * The title for the header of the expandable section
   */
  title: PropTypes.oneOfType([PropTypes.string, PropTypes.element]),

  /**
   * Text to display to the right of the heading
   */
  caption: PropTypes.oneOfType([PropTypes.string, PropTypes.element]),

  /**
   * The icon to use for collapsed groups
   */
  ExpandIcon: PropTypes.func,

  /**
   * The icon to use for expanded groups
   */
  CollapseIcon: PropTypes.func,

  /**
   * Set to false to remove the default left and right margins. Defaults to `true`.
   */
  margins: PropTypes.bool,

  /**
   * Controls the expanded state.  Defaults to false
   */
  expanded: PropTypes.bool,

  /**
   * Defaults the panel to being expanded, without controlling the state.  Defaults to false
   */
  defaultExpanded: PropTypes.bool
}), _defineProperty(_class2, "defaultProps", {
  margins: true
}), _temp)) || _class) || _class) || _class);
export { ExpandableSection as default };
//# sourceMappingURL=ExpandableSection.js.map