import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import Link from './Link';
import { withStyles } from '@material-ui/core/';
import Track from './Track';
import classnames from 'classnames';
import PropTypes from 'prop-types';
export var styles = function styles(theme) {
  return {
    logoWrap: _defineProperty({
      position: 'absolute',
      left: '50%',
      width: '120px',
      marginLeft: 'calc(-120px/2)',
      height: '100%',
      display: 'flex',
      alignItems: 'center',
      '& svg': {
        width: '100%',
        height: '100%'
      }
    }, theme.breakpoints.up('md'), {
      position: 'relative',
      left: 0,
      marginLeft: 10
    }),
    altText: {
      visibility: 'collapse',
      position: 'absolute'
    }
  };
};
/**
 * A wrapper for the logo in the app header which automatically links to the home page and fires
 * the logo_clicked analytics event
 *
 * Usage:
 *
 *  import MyLogo from '/path/to/logo.svg'
 *
 *  <HeaderLogo>
 *    <MyLogo/>
 *  </HeaderLogo>
 *
 */

var HeaderLogo = (_dec = withStyles(styles, {
  name: 'RSFHeaderLogo'
}), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(HeaderLogo, _Component);

  function HeaderLogo() {
    _classCallCheck(this, HeaderLogo);

    return _possibleConstructorReturn(this, _getPrototypeOf(HeaderLogo).apply(this, arguments));
  }

  _createClass(HeaderLogo, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          classes = _this$props.classes,
          children = _this$props.children,
          alt = _this$props.alt;
      return React.createElement(Track, {
        event: "logoClicked"
      }, React.createElement(Link, {
        to: "/",
        className: classnames(classes.logoWrap)
      }, React.createElement("span", {
        className: classes.altText
      }, alt), children));
    }
  }]);

  return HeaderLogo;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * The alt text to use for accessibility.  Defaults to "brand logo"
   */
  alt: PropTypes.string
}), _defineProperty(_class2, "defaultProps", {
  alt: 'brand logo'
}), _temp)) || _class);
export { HeaderLogo as default };
//# sourceMappingURL=HeaderLogo.js.map