import _extends from "@babel/runtime/helpers/extends";
import "core-js/modules/es6.array.fill";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component, createRef } from 'react';
import withStyles from '@material-ui/core/styles/withStyles';
import PropTypes from 'prop-types';
import { inject } from 'mobx-react';
import classnames from 'classnames';
import VisibilitySensor from 'react-visibility-sensor';
export var styles = function styles(theme) {
  return {
    root: {
      position: 'relative',
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center',
      // Without a minimum height, the container will not fire
      // the visibility change
      minHeight: 1
    },
    fit: {
      position: 'absolute',
      top: 0,
      left: 0,
      right: 0,
      bottom: 0,
      display: 'block',
      width: '100%',
      height: '100%'
    },
    contain: {
      '& img': {
        objectFit: 'contain',
        maxHeight: '100%',
        maxWidth: '100%'
      }
    },
    fill: {
      '& img': {
        display: 'block',
        objectFit: 'contain',
        maxHeight: '100%',
        maxWidth: '100%',
        width: '100%',
        height: '100%'
      }
    }
  };
};
/**
 * Provide amp-compatible mobile-optimized images that can be made to auto-scale to fit the parent element
 * by setting the `fill` prop, or grow/shrink while maintaining a given aspect ratio
 * by setting the `aspectRatio` prop.
 */

var Image = (_dec = withStyles(styles, {
  name: 'RSFImage'
}), _dec2 = inject(function (_ref) {
  var app = _ref.app;
  return {
    amp: app.amp
  };
}), _dec(_class = _dec2(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(Image, _Component);

  function Image(_ref2) {
    var _this;

    var lazy = _ref2.lazy,
        amp = _ref2.amp;

    _classCallCheck(this, Image);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Image).call(this));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleNotFound", function () {
      _this.setState({
        primaryNotFound: true
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "lazyLoad", function (visible) {
      if (!_this.state.loaded && visible) {
        _this.setState({
          loaded: true
        });
      }
    });

    _this.state = {
      loaded: !lazy || amp,
      primaryNotFound: false
    };
    _this.ref = createRef();
    return _this;
  }

  _createClass(Image, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var img = this.ref.current;

      if (img && img.complete && img.naturalWidth === 0) {
        this.handleNotFound();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _assignedAttributes, _classnames2;

      var _this$props = this.props,
          lazy = _this$props.lazy,
          lazyOffset = _this$props.lazyOffset,
          notFoundSrc = _this$props.notFoundSrc,
          height = _this$props.height,
          width = _this$props.width,
          quality = _this$props.quality,
          amp = _this$props.amp,
          fill = _this$props.fill,
          contain = _this$props.contain,
          classes = _this$props.classes,
          className = _this$props.className,
          aspectRatio = _this$props.aspectRatio,
          alt = _this$props.alt,
          src = _this$props.src,
          imgAttributes = _objectWithoutProperties(_this$props, ["lazy", "lazyOffset", "notFoundSrc", "height", "width", "quality", "amp", "fill", "contain", "classes", "className", "aspectRatio", "alt", "src"]);

      if (src == null) return null;
      var _this$state = this.state,
          loaded = _this$state.loaded,
          primaryNotFound = _this$state.primaryNotFound;
      contain = contain || aspectRatio; // Overiding `src` prop if `quality` was set

      src = this.getOptimizedSrc();

      if (primaryNotFound) {
        src = notFoundSrc;
      }

      var assignedAttributes = (_assignedAttributes = {
        src: src,
        key: src
      }, _defineProperty(_assignedAttributes, amp ? 'class' : 'className', classnames(_defineProperty({}, classes.fit, aspectRatio != null))), _defineProperty(_assignedAttributes, "layout", amp ? this.ampLayout() : null), _defineProperty(_assignedAttributes, "height", height), _defineProperty(_assignedAttributes, "width", width), _defineProperty(_assignedAttributes, "alt", alt), _assignedAttributes);
      var result = React.createElement("div", {
        className: classnames(className, (_classnames2 = {}, _defineProperty(_classnames2, classes.root, true), _defineProperty(_classnames2, classes.contain, contain), _defineProperty(_classnames2, classes.fill, fill), _classnames2))
      }, aspectRatio && React.createElement("div", {
        style: {
          paddingTop: "".concat(aspectRatio, "%")
        }
      }), amp ? React.createElement("amp-img", assignedAttributes) : loaded && React.createElement("img", _extends({
        ref: this.ref
      }, assignedAttributes, imgAttributes, {
        onError: this.handleNotFound
      })));

      if (!amp && lazy) {
        result = React.createElement(VisibilitySensor, {
          active: !loaded,
          onChange: this.lazyLoad,
          partialVisibility: true,
          offset: {
            top: -lazyOffset,
            bottom: -lazyOffset
          }
        }, result);
      }

      return result;
    }
  }, {
    key: "ampLayout",
    value: function ampLayout() {
      var _this$props2 = this.props,
          fill = _this$props2.fill,
          contain = _this$props2.contain,
          aspectRatio = _this$props2.aspectRatio;

      if (contain || fill || aspectRatio) {
        return 'fill';
      } else {
        return 'intrinsic';
      }
    }
  }, {
    key: "getOptimizedSrc",
    value: function getOptimizedSrc() {
      var _this$props3 = this.props,
          src = _this$props3.src,
          quality = _this$props3.quality;

      if (quality) {
        return "https://opt.moovweb.net/?quality=".concat(encodeURIComponent(quality), "&img=").concat(encodeURIComponent(src));
      } else {
        return src;
      }
    }
  }]);

  return Image;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * The URL for the image
   */
  src: PropTypes.string,

  /**
   * The URL of the image to use in case the primary image fails to load
   */
  notFoundSrc: PropTypes.string,

  /**
   * The ratio of height/width as a float.  For example: 1 when the height and width match,
   * 0.5 when height is half of the width.
   */
  aspectRatio: PropTypes.number,

  /**
   * The quality of image to retreive from 0 to 100
   */
  quality: PropTypes.number,

  /**
   * Set to true to apply object-fit:contain to the image so that it automatically
   * fits within the element's height and width.
   */
  contain: PropTypes.bool,

  /**
   * The same as contain, except images are stretched to fill the element's height and width.
   */
  fill: PropTypes.bool,

  /**
   * Set to true to wait until the image enters the viewport before loading it.
   */
  lazy: PropTypes.bool,

  /**
   * Sets the minimum amount of pixels the image can be scrolled out of view before it
   * is lazy loaded.  Defaults to 100.  You must set `lazy` in order for this setting to take effect.
   */
  lazyOffset: PropTypes.number
}), _defineProperty(_class2, "defaultProps", {
  quality: null,
  contain: false,
  fill: false,
  lazy: false,
  lazyOffset: 100
}), _temp)) || _class) || _class);
export { Image as default };
//# sourceMappingURL=Image.js.map