import _extends from "@babel/runtime/helpers/extends";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import SwipeableViews from 'react-swipeable-views';
import withStyles from '@material-ui/core/styles/withStyles';
import ChevronLeft from '@material-ui/icons/ChevronLeft';
import ChevronRight from '@material-ui/icons/ChevronRight';
import IconButton from '@material-ui/core/IconButton';
import Portal from '@material-ui/core/Portal';
import { fade } from '@material-ui/core/styles/colorManipulator';
import classnames from 'classnames';
import { ReactPinchZoomPan } from 'react-pinch-zoom-pan';
import TabsRow from './TabsRow';
import analytics from './analytics';
import { inject, observer } from 'mobx-react';
import AmpImageSwitcher from './amp/AmpImageSwitcher';
import LoadMask from './LoadMask';
import Image from './Image';
var paletteIconTextColor = '#77726D';
var imagePropType = PropTypes.shape({
  src: PropTypes.string.isRequired,
  alt: PropTypes.string
});
export var styles = function styles(theme) {
  return {
    root: {
      display: 'flex',
      flexDirection: 'column',
      position: 'relative',
      '& img': {
        display: 'block'
      }
    },
    swipeWrap: {
      position: 'relative',
      overflow: 'hidden',
      flex: 1,
      '& .react-swipeable-view-container, & > div:first-child': {
        height: '100%'
      }
    },
    imageWrap: {
      height: '100%',
      width: '100%',
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'stretch',
      '& img': {
        maxHeight: '100%',
        maxWidth: '100%',
        objectFit: 'contain'
      }
    },
    thumbsTitle: {
      textTransform: 'uppercase'
    },
    productThumb: {
      position: 'absolute',
      top: 0,
      left: 0,
      right: 0,
      bottom: 0
    },
    thumbs: {
      marginTop: "".concat(theme.margins.container, "px")
    },
    thumbnail: {
      paddingBottom: '8px',
      margin: '0 2px',
      boxSizing: 'content-box',
      height: '50px',
      width: '50px'
    },
    activeThumbs: {
      position: 'absolute',
      width: '100%',
      bottom: '20px'
    },
    selected: {
      borderColor: '#D0D0D0'
    },
    arrows: _defineProperty({}, theme.breakpoints.down('xs'), {
      display: 'none'
    }),
    arrow: {
      position: 'absolute',
      top: '50%',
      marginTop: '-24px'
    },
    leftArrow: {
      left: 0
    },
    rightArrow: {
      right: 0
    },
    icon: {
      height: '30px',
      width: '30px'
    },
    dot: {
      backgroundColor: fade(theme.palette.text.primary, 0.25),
      width: 8,
      height: 8,
      borderWidth: '1px',
      borderStyle: 'solid',
      borderColor: theme.palette.background.paper,
      borderRadius: '50%',
      display: 'inline-block',
      margin: '0 2px',
      // Same duration as SwipeableViews animation
      transitionDuration: '0.35s'
    },
    dotSelected: {
      backgroundColor: theme.palette.text.primary
    },
    dots: {
      position: 'absolute',
      bottom: '5px',
      textAlign: 'center',
      width: '100%'
    },
    viewerToggle: {
      transform: 'scale(0.4)',
      position: 'absolute',
      top: 0,
      right: 0,
      background: fade(theme.palette.text.icon || paletteIconTextColor, 0.4),
      borderRadius: '50%',
      width: '100px',
      height: '100px',
      transitionDuration: '0.5s',
      '-webkit-tap-highlight-color': 'rgba(0, 0, 0, 0)'
    },
    viewerActive: {
      transform: 'scale(0.4) rotateZ(45deg)'
    },
    viewerOverlay: {
      position: 'fixed',
      top: 0,
      left: 0,
      width: '100%',
      height: '100%',
      background: theme.palette.background.paper,
      zIndex: 9999,
      transitionDuration: '0.5s',
      transform: 'translateY(100%)',
      visibility: 'hidden',
      // prevents lightbox from showing near the bottom of screen when browser controls hide on ios
      '& img': {
        margin: 'auto',
        maxHeight: '100%',
        maxWidth: '100%'
      },
      // Hack to fix root div height of pan/zoom/pinch container
      '& > div:first-child': {
        height: '100%'
      }
    },
    viewerOverlayActive: {
      transform: 'translateY(0%)',
      visibility: 'visible'
    },
    tabsRowRoot: {
      boxShadow: 'none'
    },
    tabScroller: _defineProperty({}, theme.breakpoints.down('xs'), {
      padding: "0 ".concat(theme.margins.container, "px")
    }),
    indicator: {
      display: 'none'
    },
    mask: {
      opacity: '0.8'
    }
  };
};
/**
 * A swipeable image selector suitable for PDPs
 */

var ImageSwitcher = (_dec = withStyles(styles, {
  name: 'RSFImageSwitcher'
}), _dec2 = inject('app'), _dec(_class = _dec2(_class = observer(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(ImageSwitcher, _Component);

  function ImageSwitcher() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, ImageSwitcher);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(ImageSwitcher)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      selectedIndex: 0,
      productId: null,
      viewerActive: false
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "clearLoadingProduct", function () {
      _this.props.app.applyState({
        loadingProduct: null
      });
    });

    return _this;
  }

  _createClass(ImageSwitcher, [{
    key: "renderViewerToggle",
    value: function renderViewerToggle() {
      var _this2 = this;

      return React.createElement("div", {
        onClick: function onClick() {
          return _this2.toggleViewer();
        },
        className: classnames(this.props.classes.viewerToggle, _defineProperty({}, this.props.classes.viewerActive, this.state.viewerActive))
      }, React.createElement("svg", {
        width: "100",
        height: "100",
        viewBox: "0 0 100 100"
      }, React.createElement("line", {
        x1: "50",
        y1: "25",
        x2: "50",
        y2: "75",
        strokeWidth: "4",
        stroke: "white"
      }), React.createElement("line", {
        x1: "25",
        y1: "50",
        x2: "75",
        y2: "50",
        strokeWidth: "4",
        stroke: "white"
      })));
    }
  }, {
    key: "toggleViewer",
    value: function toggleViewer() {
      if (this.state.viewerActive) {
        document.body.classList.remove('moov-modal');
      } else {
        document.body.classList.add('moov-modal');
      }

      this.setState({
        viewerActive: !this.state.viewerActive
      });
    }
  }, {
    key: "renderDot",
    value: function renderDot(index) {
      var classes = classnames(this.props.classes.dot, _defineProperty({}, this.props.classes.dotSelected, index === this.state.selectedIndex));
      return React.createElement("div", {
        key: index,
        className: classes
      });
    }
  }, {
    key: "renderThumbnails",
    value: function renderThumbnails() {
      var _this3 = this;

      var _this$props = this.props,
          classes = _this$props.classes,
          thumbnailsTitle = _this$props.thumbnailsTitle,
          notFoundSrc = _this$props.notFoundSrc;
      var thumbnails = this.thumbnails;
      var modifiedThumbs = thumbnails && thumbnails.map(function (_ref) {
        var src = _ref.src,
            alt = _ref.alt;
        return {
          imageUrl: src,
          alt: alt
        };
      });
      var _this$state = this.state,
          viewerActive = _this$state.viewerActive,
          selectedIndex = _this$state.selectedIndex;
      return thumbnails && thumbnails.length > 0 && React.createElement("div", {
        className: classnames(classes.thumbs, _defineProperty({}, classes.activeThumbs, viewerActive))
      }, React.createElement("div", {
        className: "field"
      }, React.createElement("label", {
        className: classes.thumbsTitle
      }, thumbnailsTitle)), React.createElement(TabsRow, {
        classes: {
          scroller: classes.tabScroller,
          root: classes.tabsRowRoot
        },
        imageProps: {
          className: classes.thumbnail,
          notFoundSrc: notFoundSrc,
          fill: true
        },
        centered: true,
        initialSelectedIdx: selectedIndex,
        onTabChange: function onTabChange(e, selectedIndex) {
          return _this3.setState({
            selectedIndex: selectedIndex
          });
        },
        items: modifiedThumbs
      }));
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      if (prevState && prevState.selectedIndex && prevState.selectedIndex !== this.state.selectedIndex && this.props.product) {
        analytics.fire('imageSwitched', {
          product: this.props.product,
          imageUrl: this.props.images[this.state.selectedIndex]
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$props2 = this.props,
          app = _this$props2.app,
          product = _this$props2.product,
          classes = _this$props2.classes,
          className = _this$props2.className,
          arrows = _this$props2.arrows,
          indicators = _this$props2.indicators,
          style = _this$props2.style,
          reactPinchZoomPanOptions = _this$props2.reactPinchZoomPanOptions,
          loadingThumbnailProps = _this$props2.loadingThumbnailProps,
          imageProps = _this$props2.imageProps,
          viewerThumbnailsOnly = _this$props2.viewerThumbnailsOnly,
          notFoundSrc = _this$props2.notFoundSrc;
      var images = this.images,
          thumbnails = this.thumbnails;
      if (app.amp) return React.createElement(AmpImageSwitcher, _defineProperty({
        images: images,
        thumbnails: thumbnails,
        className: className,
        classes: {
          root: classes.root,
          dot: classes.dot,
          dots: classes.dots,
          dotSelected: classes.dotSelected,
          thumbnails: classes.thumbs
        },
        arrows: arrows,
        indicators: indicators
      }, "thumbnails", viewerThumbnailsOnly ? null : this.thumbnails));
      var _this$state2 = this.state,
          selectedIndex = _this$state2.selectedIndex,
          viewerActive = _this$state2.viewerActive;
      var selectedImage = images[selectedIndex];
      return React.createElement("div", {
        className: classnames(className, classes.root),
        style: style
      }, React.createElement("div", {
        className: classes.swipeWrap
      }, React.createElement(SwipeableViews, {
        index: selectedIndex,
        onChangeIndex: function onChangeIndex(i) {
          return _this4.setState({
            selectedIndex: i
          });
        }
      }, images.map(function (_ref2, i) {
        var src = _ref2.src,
            alt = _ref2.alt;
        return React.createElement("div", {
          key: i,
          className: classes.imageWrap
        }, app.amp ? React.createElement("amp-img", {
          src: src,
          alt: "product",
          layout: "fill"
        }) : React.createElement(Image, _extends({
          key: src,
          notFoundSrc: notFoundSrc,
          src: i === 0 && app.loading ? null : src // need to clear src when app.loading is true so that the onLoad event will fire and the loading thumbnail will be removed
          ,
          alt: alt || 'product',
          onLoad: i === 0 ? _this4.clearLoadingProduct : null
        }, imageProps)));
      })), arrows && React.createElement("div", {
        className: classes.arrows
      }, selectedIndex !== 0 && React.createElement(IconButton, {
        className: classnames(classes.arrow, classes.leftArrow),
        onClick: function onClick() {
          return _this4.setState({
            selectedIndex: selectedIndex - 1
          });
        }
      }, React.createElement(ChevronLeft, {
        classes: {
          root: classes.icon
        }
      })), selectedIndex !== images.length - 1 && React.createElement(IconButton, {
        className: classnames(classes.arrow, classes.rightArrow),
        onClick: function onClick() {
          return _this4.setState({
            selectedIndex: selectedIndex + 1
          });
        }
      }, React.createElement(ChevronRight, {
        classes: {
          root: classes.icon
        }
      }))), indicators && React.createElement("div", {
        className: classes.dots
      }, images.map(function (_, index) {
        return _this4.renderDot(index);
      })), product && React.createElement(LoadMask, {
        show: product.loadingImages,
        className: classes.mask
      }), product && app.loadingProduct && app.loadingProduct.thumbnail && React.createElement(Image, _extends({
        src: app.loadingProduct.thumbnail,
        className: classes.productThumb
      }, loadingThumbnailProps, {
        fill: true
      })), React.createElement(Portal, null, React.createElement("div", {
        className: classnames(classes.viewerOverlay, _defineProperty({}, classes.viewerOverlayActive, viewerActive))
      }, React.createElement(ReactPinchZoomPan, _extends({}, reactPinchZoomPanOptions, {
        render: function render(obj) {
          return React.createElement("div", {
            style: {
              overflow: 'hidden',
              position: 'relative',
              height: '100%'
            }
          }, React.createElement("div", {
            style: {
              display: 'flex',
              height: '100%'
            }
          }, selectedImage && React.createElement("img", {
            src: selectedImage.src,
            alt: selectedImage.alt,
            style: {
              width: '100%',
              height: 'auto',
              transform: "scale(".concat(obj.scale, ") translateY(").concat(obj.y, "px) translateX(").concat(obj.x, "px)")
            }
          })));
        }
      })), viewerActive && this.renderViewerToggle(), viewerActive && this.renderThumbnails())), !viewerActive && this.renderViewerToggle()), !viewerActive && !viewerThumbnailsOnly && this.renderThumbnails());
    }
  }, {
    key: "thumbnails",
    get: function get() {
      var _this$props3 = this.props,
          thumbnails = _this$props3.thumbnails,
          product = _this$props3.product;
      if (thumbnails === false) return [];

      var _thumbnails = thumbnails && thumbnails.length ? thumbnails : product && product.thumbnails || [];

      return _thumbnails.map(function (e) {
        return typeof e === 'string' ? {
          src: e,
          alt: 'thumbnail'
        } : e;
      });
    }
  }, {
    key: "images",
    get: function get() {
      var _this$props4 = this.props,
          images = _this$props4.images,
          product = _this$props4.product;

      var _images = images && images.length ? images : product && product.images || [];

      return _images.map(function (e) {
        return typeof e === 'string' ? {
          src: e,
          alt: 'product'
        } : e;
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var product = nextProps.product;
      var productId = prevState.productId;

      if (typeof nextProps.selectedIndex === 'number' && nextProps.selectedIndex !== prevState.selectedIndex) {
        // update the selectedIndex state if a new prop value is passed in
        return {
          selectedIndex: nextProps.selectedIndex
        };
      } else if (product && product.id !== productId) {
        // reset the selectedIndex state if the product changes
        return {
          productId: product.id,
          selectedIndex: 0
        };
      } else {
        return null;
      }
    }
  }]);

  return ImageSwitcher;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * If specified, then the image_switched analytics event will be
   * fired when an image is selected and the product's images and thumbnails will
   * automatically be displayed.
   */
  product: PropTypes.object,

  /**
   * An array of (URL or image object) for the full size images
   */
  images: PropTypes.arrayOf(PropTypes.oneOfType([PropTypes.string, imagePropType])).isRequired,

  /**
   * An array of thumbnails to display below the main image.  You can also
   * specify `false` to hide the thumbnails entirely.
   */
  thumbnails: PropTypes.oneOfType([PropTypes.bool, PropTypes.arrayOf(PropTypes.oneOfType([PropTypes.string, imagePropType]))]),

  /**
   * Display left/right arrows for navigating through images
   */
  arrows: PropTypes.bool,

  /**
   * Display indicator dots at the bottom of the component
   */
  indicators: PropTypes.bool,

  /**
   * Optional title for thumbnails block
   */
  thumbnailsTitle: PropTypes.string,

  /*
   * Option to show thumbnails only when zoomed view is active
   */
  viewerThumbnailsOnly: PropTypes.bool,

  /**
   * Props to apply to the Image component used to display the product thumbnail while
   * the product data is loading
   */
  loadingThumbnailProps: PropTypes.object,

  /**
   * Props to be added to the Image child components.
   */
  imageProps: PropTypes.object,

  /*
   * Option to manually set the selected index
   */
  selectedIndex: PropTypes.number,

  /**
   * The URL of image to load if an image fails to load
   */
  notFoundSrc: PropTypes.string,

  /**
   * Config options for the image viewer
   */
  reactPinchZoomPanOptions: PropTypes.shape({
    onPinchStart: PropTypes.func,
    onPinchStop: PropTypes.func,
    initialScale: PropTypes.number,
    maxScale: PropTypes.number
  })
}), _defineProperty(_class2, "defaultProps", {
  images: [],
  thumbnails: [],
  viewerThumbnailsOnly: false,
  arrows: true,
  indicators: false,
  loadingThumbnailProps: {},
  imageProps: {},
  reactPinchZoomPanOptions: {
    maxScale: 3
  }
}), _temp)) || _class) || _class) || _class);
export { ImageSwitcher as default };
//# sourceMappingURL=ImageSwitcher.js.map