import _objectSpread from "@babel/runtime/helpers/objectSpread";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import "core-js/modules/es6.regexp.search";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import { inject } from 'mobx-react';
import PropTypes from 'prop-types';
import { relativeURL, absoluteURL, canUseClientSideNavigation } from './utils/url';
import { prefetchJsonFor } from './router/serviceWorker';
import VisibilitySensor from 'react-visibility-sensor';
import withStyles from '@material-ui/core/styles/withStyles';
import classnames from 'classnames';
import dataProps from './utils/dataProps';
export var styles = {
  root: {}
};
var Link = (_dec = withStyles(styles, {
  name: 'RSFLink'
}), _dec2 = inject(function (_ref) {
  var history = _ref.history,
      router = _ref.router,
      app = _ref.app;
  return {
    history: history,
    router: router,
    location: app.location
  };
}), _dec(_class = _dec2(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(Link, _Component);

  function Link() {
    var _this;

    _classCallCheck(this, Link);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Link).call(this));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "prefetched", false);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onVisibleChange", function (visible) {
      var _this$props = _this.props,
          prefetch = _this$props.prefetch,
          onVisible = _this$props.onVisible;

      if (visible) {
        var el = _this.el.current; // Will get here if the link is on a hidden page
        // for some reason the visibility sensor fires for all links on a page right after
        // that page has been hidden.  We check el.offsetParent to make sure the link is truly visible
        // see https://stackoverflow.com/questions/19669786/check-if-element-is-visible-in-dom for more info on this method

        if (el.offsetParent != null) {
          if (prefetch === 'visible') {
            _this.prefetch();
          }

          if (onVisible) {
            onVisible();
          }
        }
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onClick", function (e) {
      var _this$props2 = _this.props,
          server = _this$props2.server,
          onClick = _this$props2.onClick,
          to = _this$props2.to,
          state = _this$props2.state,
          history = _this$props2.history;

      if (onClick) {
        onClick(e);
      }

      if (typeof state === 'function') {
        state = state();
      }

      var url = relativeURL(to);

      if (!e.isDefaultPrevented() && !server && canUseClientSideNavigation(url, _this.props.router)) {
        e.preventDefault();

        if (url === history.location.pathname + history.location.search) {
          // return immediately if the url isn't changing.  Pushing the existing URL onto state will override the
          // current state and going forward then back will yield a broken page.
          return;
        }

        if (_this.props.history) {
          _this.props.history.push(url, state && state.toJSON ? state.toJSON() : state);
        } else {
          // Fallback to redirect
          window.location.href = url;
        }
      }
    });

    _this.el = React.createRef();
    return _this;
  }

  _createClass(Link, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var prefetch = this.props.prefetch;

      if (prefetch === 'always') {
        this.prefetch();
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if (this.prefetched !== this.urlToPrefetch()) {
        // reset prefetched state if the prefetch url changes
        this.prefetched = null;
      }
    }
  }, {
    key: "prefetch",
    value: function prefetch() {
      var url = this.urlToPrefetch();

      if (this.prefetched !== url) {
        prefetchJsonFor(url);
        this.prefetched = url;
      }
    }
  }, {
    key: "urlToPrefetch",
    value: function urlToPrefetch() {
      return this.props.prefetchURL || this.props.to;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          anchorProps = _this$props3.anchorProps,
          className = _this$props3.className,
          style = _this$props3.style,
          children = _this$props3.children,
          prefetch = _this$props3.prefetch,
          to = _this$props3.to,
          location = _this$props3.location,
          onVisible = _this$props3.onVisible,
          others = _objectWithoutProperties(_this$props3, ["anchorProps", "className", "style", "children", "prefetch", "to", "location", "onVisible"]); // Here we don't provide the pathname on purpose.  Doing so would cause every link to rerender
      // We used to do that and it caused a noticeable lag in the UI.


      var href = location ? absoluteURL(to, {
        protocol: location.protocol,
        hostname: location.hostname,
        port: location.port
      }) : to;

      var props = _objectSpread({}, anchorProps, dataProps(others), {
        'data-moov-link': 'on',
        className: classnames(this.props.classes.root, className),
        ref: this.el,
        style: style,
        onClick: this.onClick,
        href: href
      });

      if (prefetch) {
        props['data-moov-rel'] = 'prefetch';
      }

      var link = React.createElement("a", props, children);

      if (prefetch === 'visible' || onVisible) {
        return React.createElement(VisibilitySensor, {
          onChange: this.onVisibleChange,
          partialVisibility: true
        }, link);
      } else {
        return link;
      }
    }
  }]);

  return Link;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * The path to navigate to when the link is clicked
   */
  to: PropTypes.string,

  /**
   * Data to assign to the history state
   */
  state: PropTypes.oneOfType([PropTypes.object, PropTypes.func]),

  /**
   * Set to true to force server side navigation.  Defaults to false
   */
  server: PropTypes.bool,

  /**
   * Set to "visible" to prefetch linked page data when the link is scrolled into view.
   * Set to "always" to prefetch even when the link is hidden.
   */
  prefetch: PropTypes.oneOf(['always', 'visible']),

  /**
   * Set this prop to prefetch a URL other than the one specified in the to prop
   */
  prefetchURL: PropTypes.string,

  /**
   * A function to call when the link is clicked.
   */
  onClick: PropTypes.func,

  /**
   * Props to apply to the underlying html anchor element
   */
  anchorProps: PropTypes.object,

  /**
   * A function to call when the link becomes visible
   */
  onVisible: PropTypes.func
}), _defineProperty(_class2, "defaultProps", {
  anchorProps: {}
}), _temp)) || _class) || _class);
export { Link as default };
//# sourceMappingURL=Link.js.map