import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { PureComponent, Fragment } from 'react';
import { observer, inject } from 'mobx-react';
import { withStyles } from '@material-ui/core';
import PropTypes from 'prop-types';
import classnames from 'classnames';
export var styles = function styles(theme) {
  return {
    root: {
      position: 'relative',
      height: '24px',
      width: '24px',
      boxSizing: 'border-box',
      display: 'flex',
      flexDirection: 'column',
      alignItems: 'center',
      '& .rsf-hamburger': {
        display: 'block',
        marginTop: '5px'
      },
      '& .rsf-hamburger-box': {
        width: '20px',
        height: '20px',
        display: 'block',
        position: 'relative'
      },
      '& .rsf-hamburger-inner': {
        display: 'block',
        top: '50%',
        marginTop: '-4px'
      },
      '& .rsf-hamburger-inner, & .rsf-hamburger-inner::before, & .rsf-hamburger-inner::after': {
        width: '20px',
        height: '2px',
        backgroundColor: theme.palette.text.secondary,
        borderRadius: '4px',
        position: 'absolute',
        transitionProperty: 'transform',
        transitionDuration: theme.transitions.duration.standard,
        transitionTimingFunction: 'ease'
      },
      '& .rsf-hamburger-inner::before, & .rsf-hamburger-inner::after': {
        content: '""',
        display: 'block'
      },
      '& .rsf-hamburger-inner::before': {
        top: '-10px'
      },
      '& .rsf-hamburger-inner::after': {
        bottom: '-10px'
      },
      '& .rsf-hamburger .rsf-hamburger-inner': {
        top: '5px'
      },
      '& .rsf-hamburger .rsf-hamburger-inner::before': {
        top: '5px',
        transitionProperty: 'transform, opacity',
        transitionTimingFunction: 'ease',
        transitionDuration: theme.transitions.duration.standard
      },
      '& .rsf-hamburger .rsf-hamburger-inner::after': {
        top: '10px'
      }
    },
    active: {
      '& .rsf-hamburger .rsf-hamburger-inner': {
        transform: 'translate3d(0, 5px, 0) rotate(45deg)'
      },
      '& .rsf-hamburger .rsf-hamburger-inner::before': {
        transform: 'rotate(-45deg) translate3d(-5.71429px, -5px, 0)',
        opacity: 0
      },
      '& .rsf-hamburger .rsf-hamburger-inner::after': {
        transform: 'translate3d(0, -10px, 0) rotate(-90deg)'
      }
    },
    withLabel: {
      '& .rsf-hamburger': {
        marginTop: '0'
      }
    },
    hidden: {
      display: 'none'
    },
    visible: {
      display: 'block'
    },
    label: {
      fontSize: '9px',
      lineHeight: '9px',
      fontWeight: 'bold',
      letterSpacing: '0px',
      marginTop: '-3px',
      color: theme.palette.text.secondary
    }
  };
};
/**
 * A menu icon that animates transitions between open and closed states.
 */

var MenuIcon = (_dec = inject('app'), _dec2 = withStyles(styles, {
  name: 'RSFMenuIcon'
}), _dec(_class = observer(_class = _dec2(_class = (_temp = _class2 =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(MenuIcon, _PureComponent);

  function MenuIcon() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, MenuIcon);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(MenuIcon)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "renderIcon", function (open, label) {
      var _classnames;

      var classes = _this.props.classes;
      return React.createElement("div", {
        className: classnames((_classnames = {}, _defineProperty(_classnames, classes.root, true), _defineProperty(_classnames, classes.active, open), _defineProperty(_classnames, classes.withLabel, label), _classnames))
      }, React.createElement("div", {
        className: "rsf-hamburger"
      }, React.createElement("span", {
        className: "rsf-hamburger-box"
      }, React.createElement("span", {
        className: "rsf-hamburger-inner"
      }))), label && React.createElement("div", {
        className: classes.label
      }, "menu"));
    });

    return _this;
  }

  _createClass(MenuIcon, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          open = _this$props.open,
          classes = _this$props.classes,
          label = _this$props.label,
          amp = _this$props.app.amp;

      if (amp) {
        return React.createElement(Fragment, null, React.createElement("div", {
          "amp-bind": "class=>menuOpen == false ? '".concat(classes.visible, "' : '").concat(classes.hidden, "'")
        }, this.renderIcon(false)), React.createElement("div", {
          className: classes.hidden,
          "amp-bind": "class=>menuOpen == true ? '".concat(classes.visible, "' : '").concat(classes.hidden, "'")
        }, this.renderIcon(true)));
      }

      return this.renderIcon(open, label);
    }
  }]);

  return MenuIcon;
}(PureComponent), _defineProperty(_class2, "propTypes", {
  /**
   * Set to true when the menu is open, otherwise false
   */
  open: PropTypes.bool,

  /**
   * Set to `false` to hide the text "menu" underneath the button when the menu is closed.
   */
  label: PropTypes.bool
}), _defineProperty(_class2, "defaultProps", {
  open: false,
  label: true
}), _temp)) || _class) || _class) || _class);
export { MenuIcon as default };
//# sourceMappingURL=MenuIcon.js.map