import "core-js/modules/es6.string.link";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _class, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import Track from './Track';
import Link from './Link';
import Tab from '@material-ui/core/Tab';
import withStyles from '@material-ui/core/styles/withStyles';
import { observer } from 'mobx-react';
import { lazyState } from './utils/state';
export var styles = function styles(theme) {
  return {
    root: _defineProperty({
      height: '56px'
    }, theme.breakpoints.up('md'), {
      minWidth: '130px'
    }),
    clickEl: {
      position: 'absolute',
      top: 0,
      left: 0,
      right: 0,
      bottom: 0,
      zIndex: 1
    },
    label: {
      whiteSpace: 'nowrap'
    },
    link: {
      display: 'block',
      height: '100%',
      fontSize: theme.typography.body1.fontSize
    },
    menu: {
      padding: "".concat(theme.margins.container, "px")
    },
    menuItem: {
      padding: "1em ".concat(theme.margins.container, "px")
    }
  };
};
var NavTab = (_dec = withStyles(styles, {
  name: 'RSFNavTab'
}), _dec(_class = observer(_class = (_temp =
/*#__PURE__*/
function (_Component) {
  _inherits(NavTab, _Component);

  function NavTab() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, NavTab);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(NavTab)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onMouseEnter", function (e) {
      _this.props.onMouseEnter({
        target: e.currentTarget,
        menu: _this.getMenu()
      });
    });

    return _this;
  }

  _createClass(NavTab, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          classes = _this$props.classes,
          state = _this$props.state,
          url = _this$props.url,
          prefetch = _this$props.prefetch,
          text = _this$props.text,
          item = _this$props.item;
      return React.createElement(Track, {
        event: "topNavClicked",
        item: item
      }, React.createElement(Link, {
        state: lazyState(state),
        className: classes.link,
        to: url,
        prefetch: prefetch,
        onClick: this.props.onClick,
        anchorProps: {
          onMouseEnter: this.onMouseEnter,
          onMouseLeave: this.props.onMouseLeave,
          'data-th': 'topNavClicked'
        }
      }, React.createElement(Tab, {
        className: classes.root,
        label: text,
        classes: {
          label: classes.label
        }
      })));
    }
  }, {
    key: "getMenu",
    value: function getMenu() {
      var _this$props2 = this.props,
          children = _this$props2.children,
          item = _this$props2.item,
          classes = _this$props2.classes,
          onItemClick = _this$props2.onItemClick;

      if (children) {
        return children;
      } else if (item.items && item.items.length) {
        return React.createElement("div", {
          className: classes.menu
        }, item.items.map(function (item, i) {
          return React.createElement("div", {
            key: i,
            className: classes.menuItem
          }, React.createElement(Link, {
            to: item.url,
            onClick: onItemClick
          }, item.text));
        }));
      } else {
        return null;
      }
    }
  }]);

  return NavTab;
}(Component), _temp)) || _class) || _class);
export { NavTab as default };
//# sourceMappingURL=NavTab.js.map