import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _extends from "@babel/runtime/helpers/extends";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import "core-js/modules/es6.array.find-index";
import "core-js/modules/es6.regexp.search";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component, Fragment } from 'react';
import { inject, observer } from 'mobx-react';
import PropTypes from 'prop-types';
import { types, getParent } from 'mobx-state-tree';
import { MenuItemModel } from './Menu';
import TabsRow from './TabsRow';
import withStyles from '@material-ui/core/styles/withStyles';
import NavTab from './NavTab';
import { relativeURL } from './utils/url';
import { Fade, Paper, Popper, Hidden } from '@material-ui/core';
import { parseState } from './utils/state';
/**
 * Scrollable navigation tabs for the top of the app. All extra props are spread to the
 * underlying Material UI Tabs element.  When a tab is clicked, the "top_nav_clicked" analytics
 * event is fired.
 */

export var styles = function styles(theme) {
  return {
    tabs: {
      maxWidth: theme.maxWidth,
      flex: 1
    },
    root: {
      zIndex: theme.zIndex.appBar - 1,
      display: 'flex',
      justifyContent: 'center',
      position: 'relative',
      borderRadius: 0,
      '&::before': {
        content: "''",
        top: 0,
        left: 0,
        width: '15px',
        height: 'calc(100% - 3px)',
        position: 'absolute',
        background: 'linear-gradient(to right, rgba(255, 255, 255, 1.0) 0%, rgba(255, 255, 255, 0.0) 100%)',
        zIndex: 1
      },
      '&::after': {
        content: "''",
        top: 0,
        right: 0,
        width: '15px',
        height: 'calc(100% - 3px)',
        position: 'absolute',
        background: 'linear-gradient(to left, rgba(255, 255, 255, 1.0) 0%, rgba(255, 255, 255, 0.0) 100%)',
        zIndex: 1
      }
    },
    menu: {
      zIndex: theme.zIndex.appBar
    },
    menuPaper: {
      borderRadius: '0',
      position: 'relative',
      top: '1px'
    },
    tab: {} // prevents MUI warning about overriding classes.tab prop

  };
};
var NavTabs = (_dec = withStyles(styles, {
  name: 'RSFNavTabs'
}), _dec2 = inject(function (_ref) {
  var app = _ref.app,
      history = _ref.history;
  return {
    tabs: app.tabs,
    history: history
  };
}), _dec(_class = _dec2(_class = observer(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(NavTabs, _Component);

  function NavTabs() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, NavTabs);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(NavTabs)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      open: false,
      menu: null,
      anchorEl: null,
      overTab: false,
      overMenu: false
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "renderTab", function (item, i) {
      return React.createElement(NavTab, _extends({}, item, {
        key: i,
        item: item,
        onMouseEnter: _this.showMenu,
        onMouseLeave: _this.onTabLeave,
        onItemClick: _this.onItemClick,
        onClick: _this.onItemClick
      }));
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "showMenu", function (_ref2) {
      var menu = _ref2.menu,
          target = _ref2.target;

      _this.setState({
        overTab: true,
        anchorEl: target,
        menu: menu
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onMenuEnter", function () {
      _this.setState({
        overMenu: true
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onMenuLeave", function () {
      _this.setState({
        overMenu: false
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onTabLeave", function () {
      _this.setState({
        overTab: false
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onItemClick", function () {
      _this.setState({
        overTab: false,
        overMenu: false
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleChange", function (_event, newValue) {
      var _this$props = _this.props,
          tabs = _this$props.tabs,
          history = _this$props.history;
      var item = tabs.items[newValue];
      var url = relativeURL(item.url);

      if (history) {
        history.push(url, parseState(item.state));
      } else {
        window.location.href = url;
      }
    });

    return _this;
  }

  _createClass(NavTabs, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          tabs = _this$props2.tabs,
          classes = _this$props2.classes,
          staticContext = _this$props2.staticContext,
          history = _this$props2.history,
          elevation = _this$props2.elevation,
          tabsProps = _objectWithoutProperties(_this$props2, ["tabs", "classes", "staticContext", "history", "elevation"]);

      var _this$state = this.state,
          menu = _this$state.menu,
          overTab = _this$state.overTab,
          overMenu = _this$state.overMenu,
          anchorEl = _this$state.anchorEl;
      var open = overTab || overMenu;
      if (!tabs) return null;
      var selected = tabs.selected;
      return React.createElement(Fragment, null, React.createElement(Paper, {
        className: classes.root,
        elevation: elevation
      }, React.createElement(TabsRow, _extends({
        initialSelectedIdx: selected,
        onTabChange: this.handleChange,
        items: tabs.items,
        tabRenderer: this.renderTab,
        centered: true,
        classes: {
          root: classes.tabs,
          tab: classes.tab
        }
      }, tabsProps))), !menu ? null : React.createElement(Hidden, {
        xsDown: true
      }, React.createElement(Popper, {
        className: classes.menu,
        open: open,
        anchorEl: anchorEl,
        transition: true
      }, function (_ref3) {
        var TransitionProps = _ref3.TransitionProps;
        return React.createElement(Fade, _extends({}, TransitionProps, {
          timeout: 350
        }), React.createElement(Paper, {
          onMouseEnter: _this2.onMenuEnter,
          onMouseLeave: _this2.onMenuLeave,
          className: classes.menuPaper
        }, menu));
      })));
    }
  }]);

  return NavTabs;
}(Component), _defineProperty(_class2, "propTypes", {
  classes: PropTypes.objectOf(PropTypes.string),

  /**
   * Controls the amount of drop shadow.
   */
  elevation: PropTypes.number
}), _defineProperty(_class2, "defaultProps", {
  elevation: 2
}), _temp)) || _class) || _class) || _class);
export { NavTabs as default };
export var TabsModel = types.model('TabsModel', {
  items: types.array(MenuItemModel)
}).views(function (self) {
  return {
    get selected() {
      var _getParent = getParent(self),
          location = _getParent.location;

      var url = location.pathname + location.search;
      var index = self.items.findIndex(function (item) {
        return item.url === url;
      });
      return index === -1 ? null : index;
    }

  };
});
//# sourceMappingURL=NavTabs.js.map