import "core-js/modules/es6.regexp.match";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import { inject, observer } from 'mobx-react';
import PropTypes from 'prop-types';
import LoadMask from './LoadMask';
import withStyles from '@material-ui/core/styles/withStyles';
import universal from 'react-universal-component';
import Container from './Container';
import Row from './Row';
import red from '@material-ui/core/colors/red';
export var styles = function styles(theme) {
  return {
    root: {
      position: 'relative',
      display: 'flex',
      flexDirection: 'column',
      alignItems: 'stretch',
      boxSizing: 'border-box'
    },
    error: {
      background: red[800],
      color: 'white',
      position: 'fixed',
      top: 0,
      left: 0,
      right: 0,
      bottom: 0,
      zIndex: 999999,
      overflow: 'auto'
    }
  };
};
/**
 * Switches the app's main view based on the value of the `page` in `AppModelBase`.  Props are spread to
 * component that is displayed.
 */

var Pages = (_dec = withStyles(styles, {
  name: 'RSFPages'
}), _dec2 = inject(function (_ref) {
  var app = _ref.app;
  return {
    app: app,
    page: app.page,
    loading: app.loading
  };
}), _dec(_class = _dec2(_class = observer(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(Pages, _Component);

  function Pages() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Pages);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Pages)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      loadingComponent: false
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "mounted", false);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "cache", {});

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "createUniversalComponent", function (comp) {
      return universal(comp, {
        loading: _this.componentLoadMask,
        onLoad: _this.onLoad,
        onError: _this.onError,
        error: _this.errorView
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onStartLoadingComponent", function () {
      if (_this.mounted) _this.setState({
        loadingComponent: true
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onEndLoadingComponent", function () {
      if (_this.mounted) _this.setState({
        loadingComponent: false
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "componentLoadMask", function () {
      return null;
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "isLoading", function () {
      return _this.props.app.loading || _this.state.loadingComponent;
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "renderLoadMask", function () {
      var _this$props = _this.props,
          loadMasks = _this$props.loadMasks,
          page = _this$props.page;
      var Mask = loadMasks[page];

      var loading = _this.isLoading();

      if (Mask) {
        return loading ? React.createElement(Mask, null) : null;
      } else {
        return React.createElement(LoadMask, {
          show: loading,
          fullscreen: true
        });
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "errorView", function (_ref2) {
      var error = _ref2.error;
      var classes = _this.props.classes;

      if (process.env.NODE_ENV === 'production') {
        var message;

        if (error.message.match(/chunk/i)) {
          message = 'An new version of the app is available.  Reloading...';
        } else {
          message = 'An error occurred while attempting to load the page. Please try again later';
        }

        return React.createElement(Container, null, React.createElement(Row, null, message));
      } else {
        return React.createElement(Container, {
          className: classes.error
        }, React.createElement("pre", null, error.stack));
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onError", function (e) {
      if (e.message.match(/chunk/i)) {
        window.location.reload();
      }
    });

    return _this;
  }

  _createClass(Pages, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this$props2 = this.props,
          components = _this$props2.components,
          app = _this$props2.app;

      if (typeof components === 'function') {
        this.components = this.props.components(this.createUniversalComponent);
      } else {
        this.components = components;
      }

      this.createAndCachePage(app.page);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.mounted = true;
    }
  }, {
    key: "componentWillUpdate",
    value: function componentWillUpdate(nextProps) {
      var page = nextProps.app.page;

      if (page !== this.page) {
        this.createAndCachePage(page);
        this.page = page;
      }
    }
    /**
     * Creates a lazy component that automatically manages the loading spinner
     * @param {React.Component} comp The component to make lazy
     * @return {React.Component}
     */

  }, {
    key: "createAndCachePage",
    value: function createAndCachePage(page) {
      if (this.cache[page]) return;
      var Comp = this.components[page];

      if (Comp) {
        this.cache[page] = {
          element: React.createElement(Comp, {
            key: page,
            onBefore: this.onStartLoadingComponent,
            onAfter: this.onEndLoadingComponent
          })
        };
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          classes = _this$props3.classes,
          app = _this$props3.app;
      var loading = this.isLoading();
      var elements = [];

      for (var page in this.cache) {
        var entry = this.cache[page];
        elements.push(React.createElement("div", {
          key: page,
          "data-page": page,
          style: {
            display: page === app.page && !loading ? 'block' : 'none'
          }
        }, entry.element));
      }

      return React.createElement("div", {
        className: classes.root
      }, this.renderLoadMask(), elements);
    }
  }]);

  return Pages;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * An object which serves as a map of page name to component to display.  When the value of `page`
   * in `AppModelBase` matches a key in this object, the corresponding component will be displayed.
   */
  components: PropTypes.oneOfType([PropTypes.object, PropTypes.func]).isRequired,

  /**
   * An object which serves as a map of page name to mask to display when the page is loading.  When the value of `page`
   * in `AppModelBase` matches a key in this object, the corresponding mask will be displayed.
   */
  loadMasks: PropTypes.object
}), _defineProperty(_class2, "defaultProps", {
  loadMasks: {},
  components: {}
}), _temp)) || _class) || _class) || _class);
export { Pages as default };
//# sourceMappingURL=Pages.js.map