import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import { Helmet } from 'react-helmet';
import classnames from 'classnames';
import withStyles from '@material-ui/core/styles/withStyles';
import { inject } from 'mobx-react';
import PropTypes from 'prop-types';
export var styles = function styles(theme) {
  return {
    root: {
      height: '300px',
      width: '450px',
      position: 'relative',
      '& > *': {
        paddingBottom: 'none'
      },
      '& *[role=button]': {
        borderRadius: '50%',
        opacity: '0.5',
        outline: 'none',
        backgroundColor: 'rgba(0,0,0,0.3)'
      }
    },
    // This fixes the issue where images do not show up sometimes when amp-carousel is placed in
    // a div with display: flex.  See https://github.com/ampproject/amphtml/issues/14519
    rootImportant: {
      '&$root': {
        display: 'block'
      }
    },
    carouselWrap: {
      height: 'calc(100% - 65px)',
      position: 'relative'
    },
    thumbnails: {
      marginTop: '10px',
      whiteSpace: 'nowrap',
      display: 'flex',
      alignItems: 'stretch',
      maxWidth: '100%',
      overflowX: 'auto'
    },
    thumbnailsWrap: {
      display: 'flex',
      margin: 'auto',
      justifyContent: 'flex-start'
    },
    thumbnail: {
      height: '70px',
      width: '50px',
      position: 'relative',
      margin: '0 2px',
      border: 'none',
      outline: 'none',
      background: 'none',
      opacity: 0.7,
      '& img': {
        objectFit: 'contain'
      }
    },
    thumbnailSelected: {
      opacity: 1
    },
    thumbnailSelectedLine: {
      borderBottom: "3px solid ".concat(theme.palette.secondary.main),
      width: '50px',
      margin: '0px 2px',
      position: 'relative',
      bottom: '4px'
    },
    dot: {},
    dots: {},
    dotSelected: {},
    '@global': {
      'amp-lightbox-gallery div[aria-label="Gallery"]': {
        display: 'none'
      }
    }
  };
};
/**
 * An AMP-compatible image switcher with pinch and zoom.
 */

var AmpImageSwitcher = (_dec = withStyles(styles, {
  name: 'RSFAmpImageSwitcher'
}), _dec2 = inject('nextId', 'ampStateId'), _dec(_class = _dec2(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(AmpImageSwitcher, _Component);

  function AmpImageSwitcher(_ref) {
    var _this;

    var id = _ref.id,
        nextId = _ref.nextId;

    _classCallCheck(this, AmpImageSwitcher);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(AmpImageSwitcher).call(this));
    id = id || nextId();
    _this.id = id || "moov-image-switcher-".concat(id);
    _this.ampStateId = "moovImageSwitcherState".concat(id);
    return _this;
  }

  _createClass(AmpImageSwitcher, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          type = _this$props.type,
          arrows = _this$props.arrows,
          indicators = _this$props.indicators,
          ampStateId = _this$props.ampStateId,
          ampStateProperty = _this$props.ampStateProperty,
          images = _this$props.images,
          thumbnails = _this$props.thumbnails,
          classes = _this$props.classes,
          className = _this$props.className;
      var id = this.id;
      return React.createElement("div", {
        className: classnames(className, classes.root, classes.rootImportant)
      }, React.createElement(Helmet, null, React.createElement("script", {
        async: true,
        "custom-element": "amp-carousel",
        src: "https://cdn.ampproject.org/v0/amp-carousel-0.1.js"
      }), React.createElement("script", {
        async: true,
        "custom-element": "amp-lightbox-gallery",
        src: "https://cdn.ampproject.org/v0/amp-lightbox-gallery-0.1.js"
      })), React.createElement("div", {
        className: classes.carouselWrap
      }, React.createElement("amp-carousel", {
        controls: arrows ? true : undefined,
        id: id,
        layout: "fill",
        type: type,
        "amp-bind": "slide=>".concat(ampStateId, ".").concat(ampStateProperty),
        on: "slideChange:AMP.setState({ ".concat(ampStateId, ": { ").concat(ampStateProperty, ": event.index } })")
      }, images.map(function (_ref2) {
        var src = _ref2.src,
            alt = _ref2.alt;
        return React.createElement("amp-img", {
          key: src,
          lightbox: true,
          src: src,
          layout: "fill",
          alt: alt
        });
      })), indicators && React.createElement("div", {
        className: classes.dots
      }, images.map(function (_ref3, i) {
        var src = _ref3.src;
        return React.createElement("div", {
          key: src,
          "amp-bind": "class=>".concat(ampStateId, ".").concat(ampStateProperty, " == ").concat(i, " ? '").concat(classes.dot, " ").concat(classes.dotSelected, "' : '").concat(classes.dot, "'"),
          className: classnames(classes.dot, _defineProperty({}, classes.dotSelected, i === 0))
        });
      }))), thumbnails && thumbnails.length > 0 && React.createElement("div", {
        className: classes.thumbnails
      }, React.createElement("div", {
        className: classes.thumbnailsWrap
      }, thumbnails.map(function (_ref4, i) {
        var src = _ref4.src,
            alt = _ref4.alt;
        return React.createElement("button", {
          key: src,
          type: "button",
          on: "tap:AMP.setState({ ".concat(ampStateId, ": { ").concat(ampStateProperty, ": ").concat(i, " }})"),
          className: classes.thumbnail
        }, React.createElement("amp-img", {
          src: src,
          alt: alt,
          layout: "fill",
          "amp-bind": "class=>".concat(ampStateId, ".").concat(ampStateProperty, " == ").concat(i, " ? '").concat(classes.thumbnail, " ").concat(classes.thumbnailSelected, "' : '").concat(classes.thumbnail, "'"),
          class: classnames(classes.thumbnail, _defineProperty({}, classes.thumbnailSelected, i === 0))
        }), i === 0 && React.createElement("div", {
          className: classes.thumbnailSelectedLine
        }));
      }))));
    }
  }]);

  return AmpImageSwitcher;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * The amp-carousel type.  Can be "slides" or "carousel".  Defaults to "slides".
   */
  type: PropTypes.oneOf(['slides', 'carousel']),

  /**
   * Set to true to display dots indicated which image in the series is selected.  Defaults to false
   */
  indicators: PropTypes.bool,

  /**
   * The property in the amp state to bind to.  Defaults to "selectedImage"
   */
  ampStateProperty: PropTypes.string,

  /**
   * Set to true to display left and right arrows.  Defaults to false
   */
  arrows: PropTypes.bool
}), _defineProperty(_class2, "defaultProps", {
  type: 'slides',
  indicators: false,
  ampStateProperty: 'selectedImage',
  controls: false
}), _temp)) || _class) || _class);
export { AmpImageSwitcher as default };
//# sourceMappingURL=AmpImageSwitcher.js.map